#!/bin/sh
#------------------------------------------------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     | Website:  https://openfoam.org
#   \\  /    A nd           | Copyright (C) 2015-2026 OpenFOAM Foundation
#    \\/     M anipulation  |
#------------------------------------------------------------------------------
# License
#     This file is part of OpenFOAM.
#
#     OpenFOAM is free software: you can redistribute it and/or modify it
#     under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#     for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
#
# Script
#     foamVTKSeries
#
# Description
#     For post-processed VTK files that form a series, foamVTKSeries writes a
#     '.vtk.series' file with filenames and corresponding times, which can be
#     opened in ParaView.
#
#     ParaView then interprets the files as a sequence which can be played with
#     video controls.
#------------------------------------------------------------------------------
error() {
    exec 1>&2
    while [ "$#" -ge 1 ]; do echo "$1"; shift; done
    usage
    exit 1
}

usage() {
        cat <<USAGE

Usage: ${0##*/} [OPTIONS] ...
options:
  -case | -c <dir>   specify case directory (default = local dir)
  -dir  | -d <dir>   post-processing directory <dir> (default = postProcessing)
  -help | -h         print the usage

For post-processed VTK files that form a series, foamVTKSeries writes a
'.vtk.series' file with filenames and corresponding times, which can be opened
in ParaView.  ParaView then interprets the files as a sequence which can be
played with video controls.

VTK files are typically written into time directories within a named "function"
sub-directory of the case 'postProcessing' directory, e.g.
'postProcessing/patchSurface/0.1/patch.vtk', where 'patchSurface' is the
function sub-directory and '0.1' is the time directory.

Series files use the same prefix as the VTK files and are written into the
function sub-directory, i.e. 'postProcessing/patchSurface/patch.vtk.series' in
our example.
USAGE
}

dir=postProcessing

while [ "$#" -gt 0 ]
do
   case "$1" in
   -c | -case)
      [ "$#" -ge 2 ] || error "'$1' option requires an argument"
      cd "$2" 2>/dev/null || error "directory does not exist:  '$2'"
      shift 2
      ;;
   -d | -dir)
      [ "$#" -ge 2 ] || error "'$1' option requires an argument"
      dir=$2
      shift 2
      ;;
   -h | -help)
      usage && exit 0
      ;;
   -*)
      error "invalid option '$1'"
      ;;
   *)
      break
      ;;
    esac
done

[ ! -d "$dir" ] && error "Cannot find postProcessing directory, exiting."

find "$dir" -mindepth 3 -name "*.vtk" | while read -r vtkFile
do
    echo "$(dirname "$(dirname "$vtkFile")")"/"$(basename "$vtkFile")"
done | sort -u | while read -r seriesName
do
    vtkFile=$(basename "$seriesName")
    vtkDir=$(dirname "$seriesName")

    echo "Sequencing all $vtkFile files in $vtkDir"

    seriesFile="$seriesName.series"

    cat > "$seriesFile" << EOF
{
    "file-series-version": "1.0",
    "files": [
EOF

    unset comma

    (cd "$vtkDir" && find -name "$vtkFile") | xargs -I {} dirname {} | \
        xargs -I {} basename {} | LC_ALL=C sort -g | while read -r time
    do
        [ "$comma" ] && printf ",\n" >> "$seriesFile" || comma=yes

        printf "        {\"name\": \"%s\", \"time\": %s }" \
            "$time/$vtkFile" "$time" >> "$seriesFile"
    done

    cat >> "$seriesFile" << EOF

    ]
}
EOF
done

#------------------------------------------------------------------------------
